/* Silent Hill Motds */

// HTML codes for the motds (feel free to edit)
new const HTML_HEAD[] = {
	"<html><head><style type=^"text/css^">h4 { margin-bottom: 4px;}</style></head><body style=^"font-family: Tahoma, Verdana; background: #000; color: #ffcc00;font-size: 13px;^"><div style=^"background: #000033; width: 100%; padding: 10px;^"><h2 style=^"margin-bottom:0px;^">"
}
new const HTML_CHEST[] = {
	"</h2></div><div style=^"background: #000022; width: 100%; padding: 10px;^">"
}
new const HTML_LEGS[] = {
	"</div></body></html>"
}

// This will create the commands help
public MOTD_ShowCredits( id )
{
	// Here we save the motd text
	static MotdText[1024], HeadLine[512];
	
	// Add the header
	formatex( MotdText, charsmax( MotdText ), "%s", HTML_HEAD );
	
	// Add the headline
	formatex( HeadLine, charsmax( HeadLine ), "%L", id, "MENU_CRED" );
	formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HeadLine );
	
	// Add the chest
	formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HTML_CHEST );
	
	// Add the text
	formatex( MotdText, charsmax( MotdText ), "%s<ul><li> DA - Developer<li> MeRcyLeZZ<li> cheap_suit<li> VEN<li> Twilight Suzuka<li> Arkshine<li> BAILOPAN<li> Model designers", MotdText );
	
	// Add the legs
	formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HTML_LEGS );
	
	// Show the motd
	show_motd( id, MotdText, HeadLine );
}

// This will create the commands help
public MOTD_Commands( id )
{
	// Here we save the motd text
	static MotdText[1024], HeadLine[512];
	
	// Add the header
	formatex( MotdText, charsmax( MotdText ), "%s", HTML_HEAD );
	
	// Add the headline
	formatex( HeadLine, charsmax( HeadLine ), "%L", id, "MENU_COM" );
	formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HeadLine );
	
	// Add the chest
	formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HTML_CHEST );
	
	// Add the text
	formatex( MotdText, charsmax( MotdText ), "%s%L", MotdText, id, "MOTD_COMMANDS" );
	
	// Add the legs
	formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HTML_LEGS );
	
	// Show the motd
	show_motd( id, MotdText, HeadLine );
}

// This will create all objective help motds
public MOTD_ObjHelp( id, iMotd )
{
	// Here we save the motd text
	static MotdText[1024], HeadLine[512];
	
	// Which motd should we show?
	switch ( iMotd )
	{
		case 0: // DE_ Maps help
		{
			// Add the html head to the text
			formatex( MotdText, charsmax( MotdText ), "%s", HTML_HEAD );
			
			// Add the head line 
			formatex( HeadLine, charsmax( HeadLine ), "%L", id, "MENU_DEMAP" );
			formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HeadLine );
			
			// Add the chest 
			formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HTML_CHEST );
			
			// Add the content
			formatex( MotdText, charsmax( MotdText ), "%s%L", MotdText, id, "MOTD_DEHELP" );
			
			// Add the legs
			formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HTML_LEGS );
		}
		
		case 1: // CS_ Maps help
		{
			// Add the html head to the text
			formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HTML_HEAD );
			
			// Add the head line 
			formatex( HeadLine, charsmax( HeadLine ), "%L", id, "MENU_CSMAP" );
			formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HeadLine )
			
			// Add the chest 
			formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HTML_CHEST );
			
			// Add the content
			formatex( MotdText, charsmax( MotdText ), "%s%L", MotdText, id, "MOTD_CSHELP" );
			
			// Add the legs
			formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HTML_LEGS );
		}
		
		case 2: // AS_ Maps help
		{
			// Add the html head to the text
			formatex( MotdText, charsmax( MotdText ), "%s", HTML_HEAD );
			
			// Add the head line 
			formatex( HeadLine, charsmax( HeadLine ), "%L", id, "MENU_ASMAP" );
			formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HeadLine )
			
			// Add the chest 
			formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HTML_CHEST );
			
			// Add the content
			formatex( MotdText, charsmax( MotdText ), "%s%L", MotdText, id, "MOTD_ASHELP" );
			
			// Add the legs
			formatex( MotdText, charsmax( MotdText ), "%s%s", MotdText, HTML_LEGS );
		}
	}
	
	// Show the motd file
	show_motd( id, MotdText, HeadLine );
}
			
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
